{"openapi":"3.0.0","info":{"title":"3rd Party Ticketing API","version":"1.0.0","description":"Please refer to the main 3rd Party Integration API documentation for general details on this API. \n\nThis document contains information on ticketing for all 3rd party ticketing systems.  APIs specific to a particular 3rd party ticketing platform are only available if the corresponding app for that platform is installed.\n"},"security":[{"ApiKeyAuth":[]}],"components":{"securitySchemes":{"ApiKeyAuth":{"type":"apiKey","in":"header","name":"Authorization"}},"parameters":{"sortAsc":{"name":"sortAsc","description":"if true, return results from oldest to newest; otherwise return results for newest to oldest\n","in":"query","schema":{"type":"boolean","default":"false","example":"false"}},"pageSize":{"name":"pageSize","description":"max number of items to retrieve per call (min 1)\n","in":"query","schema":{"type":"integer","format":"int32","default":100,"example":100}},"pageCursor":{"name":"pageCursor","description":"a cursor returned from the previous page of results that is used to move forward or backward in the result set; this should be empty / not specified for the initial page of results\n\nIf this field is provided, no other query parameters are allowed as the cursor already contains the parameters of the original query, which cannot be modified.\n","in":"query","schema":{"type":"string","example":"aHR0cDovLzE5Mi4xNjguMS4xNjo5MjAwCg=="}}},"schemas":{"ErrorResponse.v1":{"type":"object","properties":{"__object":{"$ref":"#/components/schemas/object.v1"},"__version":{"$ref":"#/components/schemas/v1"},"statusCode":{"$ref":"#/components/schemas/statusCode.v1"},"errorCodes":{"$ref":"#/components/schemas/errorCodes.v1"},"message":{"type":"string","description":"any additional messages about the status of the call","example":"This is a message to return to the user."},"privateMessage":{"$ref":"#/components/schemas/privateMessage.v1"},"requestId":{"type":"string","description":"the unique ID for the request which can be used for log tracing","example":"09895874-99BF-4203-B246-A44AC476DCD9"},"stack":{"$ref":"#/components/schemas/stack.v1"}}},"NotAuthenticatedResponse.v1":{"type":"object","properties":{"message":{"type":"string","description":"any additional messages about the status of the call","example":"This is a message to return to the user."},"requestId":{"type":"string","description":"the unique ID for the request which can be used for log tracing","example":"09895874-99BF-4203-B246-A44AC476DCD9"}}},"Page.v1":{"type":"object","properties":{"pageSize":{"type":"integer","format":"int32","description":"the number of items per page that was originally requested","example":100},"itemCount":{"type":"integer","format":"int32","description":"the total number of items on this particular page","example":3},"nextCursor":{"type":"string","description":"a page cursor to use for the next page of items\n\nNote that a nextCursor will always be available so that applications never have to re-traverse the entire set of results as items are added to the data set.\n","example":"aHR0cDovLzE5Mi4xNjguMS4xNjo5MjAwCg=="},"hasNextPage":{"type":"boolean","description":"whether or not a next page of results is currently available","example":false},"prevCursor":{"type":"string","description":"a page cursor to use for the previous page of items\n\nNote that a prevCursor will always be available so that applications never have to re-traverse the entire set of results as items are added to the data set.\n","example":"L1ZvbHVtZXMvRGF0YS9qb3NoCg=="},"hasPrevPage":{"type":"boolean","description":"whether or not a previous page of results is currently available","example":false}}},"ServiceNowConnectRequestBody.v1":{"type":"object","properties":{"organizationId":{"description":"the ID of the organization this ServiceNow account is tied to","type":"string","nullable":false,"default":null,"example":"D365AA71-F1AB-4BFF-9D15-FCEFCE2D2EAB"},"url":{"type":"string","description":"the base URL to the ServiceNow service","example":"https://servicenow.london.demo.integris.io"},"username":{"type":"string","description":"the username to use when connecting to the ServiceNow service","example":"snow_api_user"},"password":{"type":"string","description":"the password for the given username","example":"********"}}},"ServiceNowCredentials.v1":{"type":"object","properties":{"username":{"type":"string","description":"the username to use when connecting to the ServiceNow service","example":"snow_api_user"},"password":{"type":"string","description":"the password for the given username","example":"********"}}},"ServiceNowCredentialsRequestBody.v1":{"type":"object","properties":{"username":{"type":"string","description":"the username to use when connecting to the ServiceNow service","example":"snow_api_user"},"password":{"type":"string","description":"the password for the given username","example":"mypassword"}}},"ServiceNowCredentialsResponse.v1":{"type":"object","properties":{"__object":{"$ref":"#/components/schemas/object.v1"},"__version":{"$ref":"#/components/schemas/v1"},"status":{"$ref":"#/components/schemas/Status.v1"},"credentials":{"$ref":"#/components/schemas/ServiceNowCredentials.v1"}}},"ServiceNowServerInfo.v1":{"type":"object","properties":{"version":{"type":"object","properties":{"codeName":{"type":"string","description":"the friendly code name of the release","example":"London"},"server":{"type":"string","description":"the full version of the ServiceNow \"MID\" server","example":"london-06-27-2018__patch10-08-28-2019_09-06-2019_0928"}}},"lastConnectionTime":{"type":"string","description":"the last time a connection was made to the ServiceNow server; this is not present if a connection has has never been made\n","example":"2020-01-01T00:00:00Z"}}},"ServiceNowServerInfoResponse.v1":{"type":"object","properties":{"__object":{"$ref":"#/components/schemas/object.v1"},"__version":{"$ref":"#/components/schemas/v1"},"status":{"$ref":"#/components/schemas/Status.v1"},"info":{"$ref":"#/components/schemas/ServiceNowServerInfo.v1"}}},"ServiceNowStateTracking.v1":{"type":"object","properties":{"method":{"type":"string","enum":["push","pull"],"description":"the method to use for tracking ServiceNow ticket state","example":"pull"},"frequency":{"type":"number","format":"int32","description":"number of hours between ServiceNow state checks (only if method = pull)","example":6},"ignoreStates":{"type":"array","items":{"type":"string","description":"if a ticket is in this state, do not check for updates to it","example":["Closed","Resolved","Rejected"]}}}},"ServiceNowStateTrackingRequestBody.v1":{"$ref":"#/components/schemas/ServiceNowStateTracking.v1"},"ServiceNowStateTrackingResponse.v1":{"type":"object","properties":{"__object":{"$ref":"#/components/schemas/object.v1"},"__version":{"$ref":"#/components/schemas/v1"},"status":{"$ref":"#/components/schemas/Status.v1"},"stateTracking":{"$ref":"#/components/schemas/ServiceNowStateTracking.v1"}}},"ServiceNowTicketField.v1":{"type":"object","properties":{"sysId":{"type":"string","description":"the unique system ID for the ticket type in ServiceNow","example":"10843fb8dbd980108596d426ca961952"},"table":{"type":"string","description":"the name of the ServiceNow table from which the field was inherited","example":"u_integris_risk"},"name":{"type":"string","description":"the name of the ticket field in ServiceNow","example":"u_data_source_owner"},"label":{"type":"string","description":"friendly display name for the ticket field","example":"Data Source Owner"},"required":{"type":"boolean","description":"is the field required when creating a ticket","example":true},"maxLength":{"type":"number","format":"int32","description":"the maximum length of the field value","example":512},"choiceType":{"type":"string","enum":["dropdownMustChoose","dropdownWithNone","suggestion"],"description":"the type of choice that is presented to the user from ServiceNow","example":"dropdownWithNone"},"choices":{"type":"array","description":"list of potential choices for the field values\nThis field will not be present if there are no restrictions on the value for a field.\n","items":{"type":"object","properties":{"hint":{"type":"string","description":"a hint to display for the user","example":"the state of the ticket"},"label":{"type":"string","description":"the display value for the choice","example":"New"},"value":{"type":"string","description":"the actual value to store when creating the ticket","example":"1"}}}},"defaultValue":{"type":"string","description":"the default value for the field, if any","example":"josh@integris.io"},"referenceTo":{"type":"string","description":"if present, values in this field are sys_ids that refer to this type of object","example":"sys_user"}}},"ServiceNowTicketFieldListResponse.v1":{"type":"object","properties":{"__object":{"$ref":"#/components/schemas/object.v1"},"__version":{"$ref":"#/components/schemas/v1"},"status":{"$ref":"#/components/schemas/Status.v1"},"items":{"type":"array","items":{"$ref":"#/components/schemas/ServiceNowTicketField.v1"}}}},"ServiceNowTicketProfile.v1":{"type":"object","properties":{"id":{"type":"number","format":"int32","description":"the unique ID of the ticket profile","example":87},"name":{"type":"string","description":"the unique name of the ticket profile","example":"Default"},"table":{"$ref":"#/components/schemas/ServiceNowTicketProfileTable.v1"},"integrisTicketIdField":{"type":"string","description":"the name of the field, if any, in which to store the Integris ticket ID","example":"u_integris_ticket_id"},"stateField":{"$ref":"#/components/schemas/ServiceNowTicketProfileStateField.v1"},"stateColors":{"type":"object","properties":{"some_state":{"type":"string","description":"the HTML hex color code for the tag used for tickets in the given state","example":"#FF0000"},"some_other_state":{"type":"string","description":"the HTML hex color code for the tag used for tickets in the given state","example":"#00FF00"}}},"fieldMappings":{"$ref":"#/components/schemas/ServiceNowTicketProfileFieldMappings.v1"},"extraFields":{"$ref":"#/components/schemas/ServiceNowTicketProfileExtraFields.v1"}}},"ServiceNowTicketProfileExtraField.v1":{"type":"object","properties":{"field":{"type":"string","description":"the actual name of the field in ServiceNow","example":"servicenow_field_name"},"value":{"type":"string","description":"the value to use for the field","example":"some value"}}},"ServiceNowTicketProfileExtraFields.v1":{"type":"array","items":{"$ref":"#/components/schemas/ServiceNowTicketProfileExtraField.v1"}},"ServiceNowTicketProfileFieldMapping.v1":{"type":"object","properties":{"field":{"type":"string","enum":["assignedTo","dataSourceBusinessFunction","dataSourceBusinessUnit","dataSourceController","dataSourceLocation","dataSourceName","dataSourceOwner","dataSourceSystem","description","dueDate","issueDescription","issueOccurrences","issueSubject","policyName","policyType","policyRule","priority","subject","ticketCreator"],"description":"the name of the field from Integris","example":"integris_field_name"},"mapsTo":{"type":"string","description":"the actual name of the field in ServiceNow","example":"servicenow_field_name"},"required":{"type":"boolean","description":"is the field required when creating a ticket in ServiceNow","example":true},"choiceType":{"type":"string","enum":["dropdownMustChoose","dropdownWithNone","suggestion"],"description":"the type of choice that is presented to the user from ServiceNow","example":"dropdownWithNone"},"choices":{"type":"array","description":"a list of valid choices for the field values (may not be present if any value is allowed)","items":{"type":"object","properties":{"hint":{"type":"string","description":"a hint about the meaning of the value","example":""},"label":{"type":"string","description":"the friendly display value for the choice","example":"Some Choice"},"value":{"type":"string","description":"the actual value to use for the choice","example":"some_choice_value"}}}},"defaultValue":{"type":"string","description":"the default value to use for the field if it is not supplied in the ticket request","example":"the default value"}}},"ServiceNowTicketProfileFieldMappings.v1":{"type":"array","items":{"$ref":"#/components/schemas/ServiceNowTicketProfileFieldMapping.v1"}},"ServiceNowTicketProfileListResponse.v1":{"type":"object","properties":{"__object":{"$ref":"#/components/schemas/object.v1"},"__version":{"$ref":"#/components/schemas/v1"},"status":{"$ref":"#/components/schemas/Status.v1"},"items":{"type":"array","items":{"$ref":"#/components/schemas/ServiceNowTicketProfile.v1"}}}},"ServiceNowTicketProfileRequestBody.v1":{"type":"object","properties":{"name":{"type":"string","description":"the unique name of the ticket profile","example":"Default"},"table":{"$ref":"#/components/schemas/ServiceNowTicketProfileTable.v1"},"integrisTicketIdField":{"type":"string","description":"the name of the field, if any, in which to store the Integris ticket ID","example":"u_integris_ticket_id"},"stateField":{"$ref":"#/components/schemas/ServiceNowTicketProfileStateField.v1"},"fieldMappings":{"$ref":"#/components/schemas/ServiceNowTicketProfileFieldMappings.v1"},"extraFields":{"$ref":"#/components/schemas/ServiceNowTicketProfileExtraFields.v1"}}},"ServiceNowTicketProfileResponse.v1":{"type":"object","properties":{"__object":{"$ref":"#/components/schemas/object.v1"},"__version":{"$ref":"#/components/schemas/v1"},"status":{"$ref":"#/components/schemas/Status.v1"},"profile":{"$ref":"#/components/schemas/ServiceNowTicketProfile.v1"}}},"ServiceNowTicketProfileStateField.v1":{"type":"object","properties":{"field":{"type":"string","description":"the name of the field that corresponds to the ticket state","example":"state"},"choiceType":{"type":"string","enum":["dropdownMustChoose","dropdownWithNone","suggestion"],"description":"the type of choice that is presented to the user from ServiceNow","example":"dropdownWithNone"},"choices":{"type":"array","description":"a list of valid choices for the field values (may not be present if any value is allowed)","items":{"type":"object","properties":{"hint":{"type":"string","description":"a hint about the meaning of the value","example":""},"label":{"type":"string","description":"the friendly display value for the choice","example":"Some Choice"},"value":{"type":"string","description":"the actual value to use for the choice","example":"some_choice_value"}}}}}},"ServiceNowTicketProfileTable.v1":{"type":"string","description":"the name of the table in which to create tickets","example":"u_integris_risk"},"ServiceNowTicketType.v1":{"type":"object","properties":{"sysId":{"type":"string","description":"the unique system ID for the ticket type in ServiceNow","example":"10843fb8dbd980108596d426ca961952"},"name":{"type":"string","description":"the unique (table) name of the ticket type in ServiceNow","example":"u_integris_risk"},"label":{"type":"string","description":"friendly display name for the ticket type","example":"Integris Risk"},"parentClass":{"type":"string","description":"the unique system ID for the parent class ticket type (for internal use)\nNote that this field will not be present if the ticket type has no parent class.\n","example":"622805ccdb9100108596d426ca9619c7"}}},"ServiceNowTicketTypeListResponse.v1":{"type":"object","properties":{"__object":{"$ref":"#/components/schemas/object.v1"},"__version":{"$ref":"#/components/schemas/v1"},"status":{"$ref":"#/components/schemas/Status.v1"},"items":{"type":"array","items":{"$ref":"#/components/schemas/ServiceNowTicketType.v1"}}}},"ServiceNowUrlRequestBody.v1":{"type":"object","properties":{"url":{"type":"string","description":"the base URL to the ServiceNow service","example":"https://servicenow.london.demo.integris.io"}}},"ServiceNowUrlResponse.v1":{"type":"object","properties":{"__object":{"$ref":"#/components/schemas/object.v1"},"__version":{"$ref":"#/components/schemas/v1"},"status":{"$ref":"#/components/schemas/Status.v1"},"url":{"$ref":"#/components/schemas/ServiceNowUrl.v1"}}},"ServiceNowUrl.v1":{"type":"string","description":"the base URL to the ServiceNow service","example":"https://servicenow.london.demo.integris.io"},"Status.v1":{"type":"object","properties":{"message":{"type":"string","description":"any additional messages about the status of the call","example":"This is a message to return to the user."},"privateMessage":{"$ref":"#/components/schemas/privateMessage.v1"},"requestId":{"type":"string","description":"the unique ID for the request which can be used for log tracing","example":"09895874-99BF-4203-B246-A44AC476DCD9"}}},"SuccessResponse.v1":{"type":"object","properties":{"__object":{"$ref":"#/components/schemas/object.v1"},"__version":{"$ref":"#/components/schemas/v1"},"statusCode":{"$ref":"#/components/schemas/statusCode.v1"},"message":{"type":"string","description":"any additional messages about the status of the call","example":"This is a message to return to the user."},"privateMessage":{"$ref":"#/components/schemas/privateMessage.v1"},"requestId":{"type":"string","description":"the unique ID for the request which can be used for log tracing","example":"09895874-99BF-4203-B246-A44AC476DCD9"}}},"Ticket.v1":{"type":"object","properties":{"id":{"type":"number","format":"int32","description":"the unique ID for the ticket stored in the Integris database","example":101},"organizationId":{"type":"string","description":"the ID of the organization this ticket is tied to","example":"2B32F286-784A-423D-A1A3-D6DF29684E10"},"ticketProfile":{"type":"string","description":"the name of the ticket profile used to create the ticket","example":"Integris Risk"},"ticketPlatform":{"type":"string","description":"the platform on which the ticket was created","example":"servicenow"},"ticketId":{"type":"string","description":"the ticket ID in the ticketing platform to display for the end user","example":"INTRSK0001000"},"ticketUrl":{"type":"string","description":"full URL to navigate directly to the ticket in the ticketing platform","example":"https://servicenow.london.dev.integrisio.org/nav_to.do?uri=u_integris_risk.do?sys_id=222805ccdb9100108596d426ca9619d0"},"ticketDetails":{"type":"object","description":"integration-specific details about the ticket"},"state":{"type":"string","description":"current state of the ticket","example":"Open"},"lastStateUpdate":{"type":"string","format":"date-time","description":"timestamp of when the state of this ticket last changed","example":"2019-11-21T21:13:07Z"},"updateMetadata":{"$ref":"#/components/schemas/UpdateMetadata.v1"}}},"TicketAttachmentRequestBody.v1":{"type":"object","properties":{"file":{"type":"string","format":"binary","description":"the file to attach to the ticket"}}},"TicketListResponse.v1":{"type":"object","properties":{"__object":{"$ref":"#/components/schemas/object.v1"},"__version":{"$ref":"#/components/schemas/v1"},"status":{"$ref":"#/components/schemas/Status.v1"},"page":{"$ref":"#/components/schemas/Page.v1"},"items":{"type":"array","items":{"$ref":"#/components/schemas/Ticket.v1"}}}},"TicketRequestBody.v1":{"type":"object","properties":{"profileId":{"type":"string","description":"the unique ID of the ticket profile to use when creating the ticket","example":"89DD4C39-2A5E-4FE4-A0DF-195513C15FEA"},"values":{"type":"object","properties":{"some_field_name":{"type":"string","description":"key/value pair which maps the given field from the ticket profile to a value for the ticket","example":"value to set in ticket"},"some_other_field_name":{"type":"string","description":"key/value pair which maps the given field from the ticket profile to a value for the ticket","example":"value to set in ticket"}}}}},"TicketResponse.v1":{"type":"object","properties":{"status":{"$ref":"#/components/schemas/SuccessResponse.v1"},"ticket":{"$ref":"#/components/schemas/Ticket.v1"}}},"UpdateMetadata.v1":{"type":"object","properties":{"createdAt":{"type":"string","format":"date","description":"the UTC time the record was created","example":"2019-11-20 13:45:16"},"createdBy":{"type":"string","description":"the GUID of the user account which created the record","example":"1DEAA60D-07B0-45CF-9CF0-D18109F22612"},"updatedAt":{"type":"string","format":"date","description":"the UTC time the record was last updated","example":"2019-11-20 13:45:16"},"updatedBy":{"type":"string","description":"the GUID of the user account which last updated the record","example":"1DEAA60D-07B0-45CF-9CF0-D18109F22612"}}},"errorCodes.v1":{"type":"array","items":{"type":"string"},"description":"one or more internal status/error codes for troubleshooting purposes","example":["status_code_1","status_code_2"]},"object.v1":{"type":"string","description":"the full type of the object, including API version","example":"SomeObject.v1"},"privateMessage.v1":{"type":"string","description":"a private message that should not be shared with end users but may be helpful in debugging; this field may not be present if no additional information is available\n","example":"This is some internal information that should not be shown in the UI."},"stack.v1":{"type":"string","description":"the call stack at the time the error occurred","example":"'Error: Failed to process request: The uploaded package does not appear to be a valid ZIP file.\\n    at Function.exception.invalidDataException (/home/integris/www/api/common/exception.js:162:15)\\n    at loadManifest (/home/integris/www/api/thirdParty/integrations/util/package.js:136:40)\\n    at installAsync (/home/integris/www/api/thirdParty/integrations/workflows/install.js:95:35)\\n    at process._tickCallback (internal/process/next_tick.js:68:7)'\n"},"statusCode.v1":{"type":"number","format":"int32","description":"the HTTP status code"},"v1":{"type":"number","format":"int32","description":"the API version of the object","example":1}}},"paths":{"/api/ticketing/tickets":{"get":{"tags":["Ticketing"],"summary":"gets a list of tickets being tracked by the platform","description":"queries the database and retrieves either all tickets that are currently being tracked or filters the list according to search criteria\n","parameters":[{"name":"organizationId","description":"filter tickets returning only those owned by the given organization ID(s); separate multiple IDs with a comma\n","in":"query","schema":{"type":"string","nullable":true,"default":null,"example":"D365AA71-F1AB-4BFF-9D15-FCEFCE2D2EAB"}},{"name":"ticketId","description":"filter tickets returning only those with the given ticket ID(s) - this is the ticket ID from the 3rd party platform; use integrisTicketId for the Integris ticket ID; separate multiple IDs with a comma\n\nThis field is case-sensitive.\n","in":"query","schema":{"type":"string","nullable":true,"default":null,"example":"INTRSK00007,INTRSK00008"}},{"name":"integrisTicketId","description":"filter tickets returning only those with the given Integris ticket ID(s) - this is the internal ticket ID; use ticketId for the 3rd party ticket ID; separate multiple IDs with a comma\n","in":"query","schema":{"type":"number","format":"int32","nullable":true,"default":null,"example":"2,4,6,10"}},{"name":"platform","description":"filter tickets returning only those opened on the given ticketing platform(s); separate multiple platforms with a comma\n\nThis field is *not* case-sensitive.\n","in":"query","schema":{"type":"string","nullable":true,"default":null,"example":"servicenow,jira"}},{"name":"profile","description":"filter tickets returning only those having been opened using the given ticket profile(s); separate multiple profiles with a comma\n\nThis field *not* is case-sensitive.\n","in":"query","schema":{"type":"string","nullable":true,"default":null,"example":"default,integris risk"}},{"name":"state","description":"filter tickets returning only those with the given state(s); separate multiple states with a comma\n\nThis field is *not* case-sensitive.\n","in":"query","schema":{"type":"string","nullable":true,"default":null,"example":"Open"}},{"name":"lastStateUpdateBefore","description":"filter tickets returning only those where the state was last updated at or before the given date and time; must be formatted as ISO 8601 in UTC\n","in":"query","schema":{"type":"string","nullable":true,"default":null,"example":"2020-01-01T00:00:00Z"}},{"name":"lastStateUpdateAfter","description":"filter tickets returning only those where the state was last updated at or after the given date and time; must be formatted as ISO 8601 in UTC\n","in":"query","schema":{"type":"string","nullable":true,"default":null,"example":"2020-01-01T00:00:00Z"}},{"$ref":"#/components/parameters/sortAsc"},{"$ref":"#/components/parameters/pageSize"},{"$ref":"#/components/parameters/pageCursor"}],"responses":{"200":{"description":"the request was successful","content":{"application/json":{"schema":{"$ref":"#/components/schemas/TicketListResponse.v1"}},"application/vnd.integrisio.ticket.v1+json":{"schema":{"$ref":"#/components/schemas/TicketListResponse.v1"}}}},"400":{"description":"there is an issue with the client request","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ErrorResponse.v1"}},"application/vnd.integrisio.ticket.v1+json":{"schema":{"$ref":"#/components/schemas/ErrorResponse.v1"}}}},"401":{"description":"the user is not authenticated with the API","content":{"application/json":{"schema":{"$ref":"#/components/schemas/NotAuthenticatedResponse.v1"}}}},"415":{"description":"none of the media types requested in the Accept header are supported","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ErrorResponse.v1"}}}},"500":{"description":"there was an error on the server while processing the request","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ErrorResponse.v1"}},"application/vnd.integrisio.ticket.v1+json":{"schema":{"$ref":"#/components/schemas/ErrorResponse.v1"}}}}}},"post":{"tags":["Ticketing"],"summary":"create a new ticket in a 3rd party platform","description":"creates a new ticket in the database as well as the 3rd party platform\n\nNote that for values keys should represent one of the field mapping keys from the ticket profile. Any key that does not have a value present will not be added to the ticket.  Valid keys are:\n- accountId - the GUID of the account who is opening the ticket; if this is provided, the email address of the account will be used for the ticketCreator field unless it is specifcally defined\n              \n- assignedTo\n- connectorInstanceId - the GUID of the data source for which the ticket is being opened; if this is provided, it will automatically populate the dataSourceXXX fields unless they are specifically included\n- dataSourceBusinessFunction\n- dataSourceBusinessUnit\n- dataSourceController\n- dataSourceLocation\n- dataSourceName\n- dataSourceOwner\n- dataSourceSystem\n- description\n- dueDate\n- policyName\n- priority\n- riskDescription\n- riskID - the GUID of the risk entry for which th - riskIncidentId - the GUID of the risk incident entry for which the ticket is being opened; if this is provided, it\n  will automatically populate the policyXXX, riskXXX and ruleXXX as well as the dataSourceXXX fields unless they\n  are specifically included\n\n- riskIncidentOccurrences\n- riskIssueNumber\n- riskSubject\n- ruleName\n- ruleType\n- subject\n- ticketCreator\n\nIf a particular field has a set of 'choices' associated with it, the value supplied must be one of the valid choices or the creation will fail with an HTTP 400 error.  Likewise if a particular field is marked as required in the ticket profile but is missing, the creation will also fail with an HTTP 400 error.  Any 'extras' fields associated with the ticket profile will be automatically added to the ticket during creation.\n","parameters":[],"requestBody":{"required":true,"content":{"application/json":{"schema":{"$ref":"#/components/schemas/TicketRequestBody.v1"}},"application/vnd.integrisio.ticket.v1+json":{"schema":{"$ref":"#/components/schemas/TicketRequestBody.v1"}}}},"responses":{"200":{"description":"the request was successful\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/TicketResponse.v1"}},"application/vnd.integrisio.ticket.v1+json":{"schema":{"$ref":"#/components/schemas/TicketResponse.v1"}}}},"400":{"description":"there is an issue with the client request","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ErrorResponse.v1"}},"application/vnd.integrisio.ticket.v1+json":{"schema":{"$ref":"#/components/schemas/ErrorResponse.v1"}}}},"401":{"description":"the user is not authenticated with the API","content":{"application/json":{"schema":{"$ref":"#/components/schemas/NotAuthenticatedResponse.v1"}}}},"415":{"description":"none of the media types requested in the Accept header are supported","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ErrorResponse.v1"}}}},"500":{"description":"there was an error on the server while processing the request","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ErrorResponse.v1"}},"application/vnd.integrisio.ticket.v1+json":{"schema":{"$ref":"#/components/schemas/ErrorResponse.v1"}}}}}}},"/api/ticketing/tickets/:id/attachments":{"post":{"tags":["Ticketing"],"summary":"attaches a file to the given ticket in the 3rd party platform","description":"This API call allows you to upload a file and attach it to an existing ticket.\n","parameters":[{"name":"id","description":"the unique ID of the ticket in the Integris database","in":"path","required":true,"schema":{"type":"string","nullable":false,"example":"7"}}],"requestBody":{"required":true,"content":{"multipart/form-data":{"schema":{"$ref":"#/components/schemas/TicketAttachmentRequestBody.v1"}}}},"responses":{"200":{"description":"the request was successful","content":{"application/json":{"schema":{"$ref":"#/components/schemas/SuccessResponse.v1"}},"application/vnd.integrisio.ticket.v1+json":{"schema":{"$ref":"#/components/schemas/SuccessResponse.v1"}}}},"400":{"description":"there is an issue with the client request","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ErrorResponse.v1"}},"application/vnd.integrisio.ticket.v1+json":{"schema":{"$ref":"#/components/schemas/ErrorResponse.v1"}}}},"401":{"description":"the user is not authenticated with the API","content":{"application/json":{"schema":{"$ref":"#/components/schemas/NotAuthenticatedResponse.v1"}}}},"404":{"description":"the ticket was not found in ServiceNow","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ErrorResponse.v1"}},"application/vnd.integrisio.ticket.v1+json":{"schema":{"$ref":"#/components/schemas/ErrorResponse.v1"}}}},"415":{"description":"none of the media types requested in the Accept header are supported","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ErrorResponse.v1"}}}},"500":{"description":"there was an error on the server while processing the request","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ErrorResponse.v1"}},"application/vnd.integrisio.ticket.v1+json":{"schema":{"$ref":"#/components/schemas/ErrorResponse.v1"}}}}}}},"/api/ticketing/tickets/:id/refresh":{"post":{"tags":["Ticketing"],"summary":"refreshes 3rd party ticket details, including state, in the database","description":"This API call is used to periodically refresh the cached details of 3rd party ticket in the Integris database. During the refresh, the Integris state is updated as well if the ticket's state has changed since it was last refreshed.\n\nThis call can be used internally to force a refresh manually or periodically, or it can be called by the 3rd party ticketing platform to force a refresh to occur on demand.\n","parameters":[{"name":"id","description":"the ID of the ticket in the Integris database","in":"path","required":true,"schema":{"type":"string","nullable":false,"default":null,"example":"123"}}],"responses":{"200":{"description":"the request was successful\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/TicketResponse.v1"}},"application/vnd.integrisio.ticket.v1+json":{"schema":{"$ref":"#/components/schemas/TicketResponse.v1"}}}},"400":{"description":"there is an issue with the client request","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ErrorResponse.v1"}},"application/vnd.integrisio.ticket.v1+json":{"schema":{"$ref":"#/components/schemas/ErrorResponse.v1"}}}},"401":{"description":"the user is not authenticated with the API","content":{"application/json":{"schema":{"$ref":"#/components/schemas/NotAuthenticatedResponse.v1"}}}},"404":{"description":"no matching ticket was found","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ErrorResponse.v1"}},"application/vnd.integrisio.ticket.v1+json":{"schema":{"$ref":"#/components/schemas/ErrorResponse.v1"}}}},"415":{"description":"none of the media types requested in the Accept header are supported","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ErrorResponse.v1"}}}},"500":{"description":"there was an error on the server while processing the request","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ErrorResponse.v1"}},"application/vnd.integrisio.ticket.v1+json":{"schema":{"$ref":"#/components/schemas/ErrorResponse.v1"}}}}}}},"/api/ticketing/ticketAssociations/risks/:riskId":{"get":{"tags":["Ticketing"],"summary":"gets a list of tickets associated with the given risk","description":"queries the database and retrieves either all tickets that are currently associated with the given risk or filters the list according to search criteria\n\nNote that if the given risk ID does not exist, this API will still return an HTTP 200 code but will have an empty list of tickets.\n","parameters":[{"$ref":"#/components/parameters/sortAsc"},{"$ref":"#/components/parameters/pageSize"},{"$ref":"#/components/parameters/pageCursor"}],"responses":{"200":{"description":"the request was successful","content":{"application/json":{"schema":{"$ref":"#/components/schemas/TicketListResponse.v1"}},"application/vnd.integrisio.ticket.v1+json":{"schema":{"$ref":"#/components/schemas/TicketListResponse.v1"}}}},"400":{"description":"there is an issue with the client request","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ErrorResponse.v1"}},"application/vnd.integrisio.ticket.v1+json":{"schema":{"$ref":"#/components/schemas/ErrorResponse.v1"}}}},"401":{"description":"the user is not authenticated with the API","content":{"application/json":{"schema":{"$ref":"#/components/schemas/NotAuthenticatedResponse.v1"}}}},"415":{"description":"none of the media types requested in the Accept header are supported","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ErrorResponse.v1"}}}},"500":{"description":"there was an error on the server while processing the request","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ErrorResponse.v1"}},"application/vnd.integrisio.ticket.v1+json":{"schema":{"$ref":"#/components/schemas/ErrorResponse.v1"}}}}}}},"/api/apps/servicenow/connect":{"post":{"tags":["ServiceNow"],"summary":"tests the configured credentials and URL to ensure compatibility","description":"This API connects to ServiceNow using the configured credentials and URL (set via Integration Settings APIs) and checks to make sure the version of ServiceNow you are connecting to is compatible with the current ServiceNow integration app.\n\nIf there is a compatibility issue, a 409 Conflict error is returned.\n","requestBody":{"required":false,"description":"If desired, send the URL, username and password to this API call to automatically test and store these parameters. If any parameter is not specified, the value stored by a previous call to the 'credentials' or 'url' setting APIs will be used instead.  'organizationId' is required.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ServiceNowConnectRequestBody.v1"}},"application/vnd.integrisio.servicenow-config.v1+json":{"schema":{"$ref":"#/components/schemas/ServiceNowConnectRequestBody.v1"}}}},"responses":{"200":{"description":"the request was successful\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/SuccessResponse.v1"}},"application/vnd.integrisio.servicenow-config.v1+json":{"schema":{"$ref":"#/components/schemas/SuccessResponse.v1"}}}},"400":{"description":"there is an issue with the client request","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ErrorResponse.v1"}},"application/vnd.integrisio.servicenow-config.v1+json":{"schema":{"$ref":"#/components/schemas/ErrorResponse.v1"}}}},"401":{"description":"the user is not authenticated with the API","content":{"application/json":{"schema":{"$ref":"#/components/schemas/NotAuthenticatedResponse.v1"}}}},"409":{"description":"the current version of the integration app is not compatible with the server version of ServiceNow","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ErrorResponse.v1"}},"application/vnd.integrisio.servicenow-config.v1+json":{"schema":{"$ref":"#/components/schemas/ErrorResponse.v1"}}}},"415":{"description":"none of the media types requested in the Accept header are supported","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ErrorResponse.v1"}}}},"500":{"description":"there was an error on the server while processing the request","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ErrorResponse.v1"}},"application/vnd.integrisio.servicenow-config.v1+json":{"schema":{"$ref":"#/components/schemas/ErrorResponse.v1"}}}}}}},"/api/apps/servicenow/settings/:organizationId/credentials":{"get":{"tags":["ServiceNow"],"summary":"gets the credentials for the ServiceNow server","description":"This API call returns the currently configured credentials for ServiceNow.  Any password information is masked.\n","parameters":[{"name":"organizationId","description":"the ID of the organization this ServiceNow account is tied to","in":"path","required":true,"schema":{"type":"string","nullable":false,"default":null,"example":"D365AA71-F1AB-4BFF-9D15-FCEFCE2D2EAB"}}],"responses":{"200":{"description":"the request was successful\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ServiceNowCredentialsResponse.v1"}},"application/vnd.integrisio.servicenow-config.v1+json":{"schema":{"$ref":"#/components/schemas/ServiceNowCredentialsResponse.v1"}}}},"400":{"description":"there is an issue with the client request","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ErrorResponse.v1"}},"application/vnd.integrisio.servicenow-config.v1+json":{"schema":{"$ref":"#/components/schemas/ErrorResponse.v1"}}}},"401":{"description":"the user is not authenticated with the API","content":{"application/json":{"schema":{"$ref":"#/components/schemas/NotAuthenticatedResponse.v1"}}}},"404":{"description":"no credentials have been set","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ErrorResponse.v1"}},"application/vnd.integrisio.servicenow-config.v1+json":{"schema":{"$ref":"#/components/schemas/ErrorResponse.v1"}}}},"409":{"description":"multiple credential settings were found","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ErrorResponse.v1"}},"application/vnd.integrisio.servicenow-config.v1+json":{"schema":{"$ref":"#/components/schemas/ErrorResponse.v1"}}}},"415":{"description":"none of the media types requested in the Accept header are supported","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ErrorResponse.v1"}}}},"500":{"description":"there was an error on the server while processing the request","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ErrorResponse.v1"}},"application/vnd.integrisio.servicenow-config.v1+json":{"schema":{"$ref":"#/components/schemas/ErrorResponse.v1"}}}}}},"put":{"tags":["ServiceNow"],"summary":"sets or updates the credentials for the ServiceNow server","description":"This sets the account to use when connecting to the ServiceNow API.  Neither value is required and can be set independently of the other.\n\nYou should call the \"connect\" API to ensure the new credentials are working properly after setting them.\n","parameters":[{"name":"organizationId","description":"the ID of the organization this ServiceNow account is tied to","in":"path","required":true,"schema":{"type":"string","nullable":false,"default":null,"example":"D365AA71-F1AB-4BFF-9D15-FCEFCE2D2EAB"}}],"requestBody":{"required":true,"content":{"application/json":{"schema":{"$ref":"#/components/schemas/ServiceNowCredentialsRequestBody.v1"}},"application/vnd.integrisio.servicenow-config.v1+json":{"schema":{"$ref":"#/components/schemas/ServiceNowCredentialsRequestBody.v1"}}}},"responses":{"200":{"description":"the request was successful\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/SuccessResponse.v1"}},"application/vnd.integrisio.servicenow-config.v1+json":{"schema":{"$ref":"#/components/schemas/SuccessResponse.v1"}}}},"400":{"description":"there is an issue with the client request","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ErrorResponse.v1"}},"application/vnd.integrisio.servicenow-config.v1+json":{"schema":{"$ref":"#/components/schemas/ErrorResponse.v1"}}}},"401":{"description":"the user is not authenticated with the API","content":{"application/json":{"schema":{"$ref":"#/components/schemas/NotAuthenticatedResponse.v1"}}}},"409":{"description":"multiple credential settings were found","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ErrorResponse.v1"}},"application/vnd.integrisio.servicenow-config.v1+json":{"schema":{"$ref":"#/components/schemas/ErrorResponse.v1"}}}},"415":{"description":"none of the media types requested in the Accept header are supported","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ErrorResponse.v1"}}}},"500":{"description":"there was an error on the server while processing the request","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ErrorResponse.v1"}},"application/vnd.integrisio.servicenow-config.v1+json":{"schema":{"$ref":"#/components/schemas/ErrorResponse.v1"}}}}}}},"/api/apps/servicenow/settings/:organizationId/serverInfo":{"get":{"tags":["ServiceNow"],"summary":"gets the ServiceNow server information","description":"This API retrieves information about the ServiceNow platform that the API is connecting to.\n\nYou must call the 'connect' API call before attempting to call this API.\n","parameters":[{"name":"organizationId","description":"the ID of the organization this ServiceNow account is tied to","in":"path","required":true,"schema":{"type":"string","nullable":false,"default":null,"example":"D365AA71-F1AB-4BFF-9D15-FCEFCE2D2EAB"}}],"responses":{"200":{"description":"the request was successful\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ServiceNowServerInfoResponse.v1"}},"application/vnd.integrisio.servicenow-config.v1+json":{"schema":{"$ref":"#/components/schemas/ServiceNowServerInfoResponse.v1"}}}},"400":{"description":"there is an issue with the client request","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ErrorResponse.v1"}},"application/vnd.integrisio.servicenow-config.v1+json":{"schema":{"$ref":"#/components/schemas/ErrorResponse.v1"}}}},"401":{"description":"the user is not authenticated with the API","content":{"application/json":{"schema":{"$ref":"#/components/schemas/NotAuthenticatedResponse.v1"}}}},"415":{"description":"none of the media types requested in the Accept header are supported","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ErrorResponse.v1"}}}},"500":{"description":"there was an error on the server while processing the request","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ErrorResponse.v1"}},"application/vnd.integrisio.servicenow-config.v1+json":{"schema":{"$ref":"#/components/schemas/ErrorResponse.v1"}}}}}}},"/api/apps/servicenow/settings/:organizationId/stateTracking":{"get":{"tags":["ServiceNow"],"summary":"gets the state tracking settings for ServiceNow","description":"This API call returns the currently configured state tracking settings for ServiceNow.\n","parameters":[{"name":"organizationId","description":"the ID of the organization this ServiceNow account is tied to","in":"path","required":true,"schema":{"type":"string","nullable":false,"default":null,"example":"D365AA71-F1AB-4BFF-9D15-FCEFCE2D2EAB"}}],"responses":{"200":{"description":"the request was successful\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ServiceNowStateTrackingResponse.v1"}},"application/vnd.integrisio.servicenow-config.v1+json":{"schema":{"$ref":"#/components/schemas/ServiceNowStateTrackingResponse.v1"}}}},"400":{"description":"there is an issue with the client request","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ErrorResponse.v1"}},"application/vnd.integrisio.servicenow-config.v1+json":{"schema":{"$ref":"#/components/schemas/ErrorResponse.v1"}}}},"401":{"description":"the user is not authenticated with the API","content":{"application/json":{"schema":{"$ref":"#/components/schemas/NotAuthenticatedResponse.v1"}}}},"404":{"description":"no state tracking settings have been set","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ErrorResponse.v1"}},"application/vnd.integrisio.servicenow-config.v1+json":{"schema":{"$ref":"#/components/schemas/ErrorResponse.v1"}}}},"409":{"description":"multiple settings were found","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ErrorResponse.v1"}},"application/vnd.integrisio.servicenow-config.v1+json":{"schema":{"$ref":"#/components/schemas/ErrorResponse.v1"}}}},"415":{"description":"none of the media types requested in the Accept header are supported","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ErrorResponse.v1"}}}},"500":{"description":"there was an error on the server while processing the request","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ErrorResponse.v1"}},"application/vnd.integrisio.servicenow-config.v1+json":{"schema":{"$ref":"#/components/schemas/ErrorResponse.v1"}}}}}},"put":{"tags":["ServiceNow"],"summary":"saves the state tracking settings for ServiceNow","description":"This API call saves the state tracking settings for ServiceNow.\n","parameters":[{"name":"organizationId","description":"the ID of the organization this ServiceNow account is tied to","in":"path","required":true,"schema":{"type":"string","nullable":false,"default":null,"example":"D365AA71-F1AB-4BFF-9D15-FCEFCE2D2EAB"}}],"requestBody":{"required":true,"content":{"application/json":{"schema":{"$ref":"#/components/schemas/ServiceNowStateTrackingRequestBody.v1"}},"application/vnd.integrisio.servicenow-config.v1+json":{"schema":{"$ref":"#/components/schemas/ServiceNowStateTrackingRequestBody.v1"}}}},"responses":{"200":{"description":"the request was successful\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/SuccessResponse.v1"}},"application/vnd.integrisio.servicenow-config.v1+json":{"schema":{"$ref":"#/components/schemas/SuccessResponse.v1"}}}},"400":{"description":"there is an issue with the client request","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ErrorResponse.v1"}},"application/vnd.integrisio.servicenow-config.v1+json":{"schema":{"$ref":"#/components/schemas/ErrorResponse.v1"}}}},"401":{"description":"the user is not authenticated with the API","content":{"application/json":{"schema":{"$ref":"#/components/schemas/NotAuthenticatedResponse.v1"}}}},"409":{"description":"multiple URL settings were found","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ErrorResponse.v1"}},"application/vnd.integrisio.servicenow-config.v1+json":{"schema":{"$ref":"#/components/schemas/ErrorResponse.v1"}}}},"415":{"description":"none of the media types requested in the Accept header are supported","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ErrorResponse.v1"}}}},"500":{"description":"there was an error on the server while processing the request","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ErrorResponse.v1"}},"application/vnd.integrisio.servicenow-config.v1+json":{"schema":{"$ref":"#/components/schemas/ErrorResponse.v1"}}}}}}},"/api/apps/servicenow/settings/:organizationId/ticketProfiles":{"get":{"tags":["ServiceNow"],"summary":"get the list of available ticket profiles","description":"This API queries the database and returns all of the available ticket profiles.\n\nNote that ticket profile names are not case-sensitive, however, they are stored using the exact case that was specified when the profile was last updated or initially created.\n","parameters":[{"name":"organizationId","description":"the ID of the organization this ServiceNow account is tied to","in":"path","required":true,"schema":{"type":"string","nullable":false,"default":null,"example":"D365AA71-F1AB-4BFF-9D15-FCEFCE2D2EAB"}},{"name":"name","description":"filter profiles returning only those with the given setting name(s); separate multiple names with a comma\n\nThis field is *not* case-sensitive.\n","in":"query","schema":{"type":"string","nullable":true,"default":null,"example":"Default,HighAlert"}}],"responses":{"200":{"description":"the request was successful\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ServiceNowTicketProfileListResponse.v1"}},"application/vnd.integrisio.servicenow-config.v1+json":{"schema":{"$ref":"#/components/schemas/ServiceNowTicketProfileListResponse.v1"}}}},"400":{"description":"there is an issue with the client request","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ErrorResponse.v1"}},"application/vnd.integrisio.servicenow-config.v1+json":{"schema":{"$ref":"#/components/schemas/ErrorResponse.v1"}}}},"401":{"description":"the user is not authenticated with the API","content":{"application/json":{"schema":{"$ref":"#/components/schemas/NotAuthenticatedResponse.v1"}}}},"415":{"description":"none of the media types requested in the Accept header are supported","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ErrorResponse.v1"}}}},"500":{"description":"there was an error on the server while processing the request","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ErrorResponse.v1"}},"application/vnd.integrisio.servicenow-config.v1+json":{"schema":{"$ref":"#/components/schemas/ErrorResponse.v1"}}}}}},"post":{"tags":["ServiceNow"],"summary":"creates a new ticket profile","description":"This API creates a new ticket profile.\n\nNote that ticket profile names are not case-sensitive, however, they will be stored using the exact case as specified for the name.\n","parameters":[{"name":"organizationId","description":"the ID of the organization this ServiceNow account is tied to","in":"path","required":true,"schema":{"type":"string","nullable":false,"default":null,"example":"D365AA71-F1AB-4BFF-9D15-FCEFCE2D2EAB"}}],"requestBody":{"required":true,"content":{"application/json":{"schema":{"$ref":"#/components/schemas/ServiceNowTicketProfileRequestBody.v1"}},"application/vnd.integrisio.servicenow-config.v1+json":{"schema":{"$ref":"#/components/schemas/ServiceNowTicketProfileRequestBody.v1"}}}},"responses":{"200":{"description":"the request was successful\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ServiceNowTicketProfileResponse.v1"}},"application/vnd.integrisio.servicenow-config.v1+json":{"schema":{"$ref":"#/components/schemas/ServiceNowTicketProfileResponse.v1"}}}},"400":{"description":"there is an issue with the client request","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ErrorResponse.v1"}},"application/vnd.integrisio.servicenow-config.v1+json":{"schema":{"$ref":"#/components/schemas/ErrorResponse.v1"}}}},"401":{"description":"the user is not authenticated with the API","content":{"application/json":{"schema":{"$ref":"#/components/schemas/NotAuthenticatedResponse.v1"}}}},"409":{"description":"multiple ticket profiles with the given name were found","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ErrorResponse.v1"}},"application/vnd.integrisio.servicenow-config.v1+json":{"schema":{"$ref":"#/components/schemas/ErrorResponse.v1"}}}},"415":{"description":"none of the media types requested in the Accept header are supported","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ErrorResponse.v1"}}}},"500":{"description":"there was an error on the server while processing the request","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ErrorResponse.v1"}},"application/vnd.integrisio.servicenow-config.v1+json":{"schema":{"$ref":"#/components/schemas/ErrorResponse.v1"}}}}}}},"/api/apps/servicenow/settings/:organizationId/ticketProfiles/:id":{"get":{"tags":["ServiceNow"],"summary":"gets the ticket profile","description":"This API call returns the given ticket profile for ServiceNow.\n","parameters":[{"name":"organizationId","description":"the ID of the organization this ServiceNow account is tied to","in":"path","required":true,"schema":{"type":"string","nullable":false,"default":null,"example":"D365AA71-F1AB-4BFF-9D15-FCEFCE2D2EAB"}},{"name":"id","description":"the ID of the ticket profile being updated","in":"path","required":true,"schema":{"type":"number","format":"int32","nullable":true,"default":null,"example":17}}],"responses":{"200":{"description":"the request was successful\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ServiceNowTicketProfileResponse.v1"}},"application/vnd.integrisio.servicenow-config.v1+json":{"schema":{"$ref":"#/components/schemas/ServiceNowTicketProfileResponse.v1"}}}},"400":{"description":"there is an issue with the client request","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ErrorResponse.v1"}},"application/vnd.integrisio.servicenow-config.v1+json":{"schema":{"$ref":"#/components/schemas/ErrorResponse.v1"}}}},"401":{"description":"the user is not authenticated with the API","content":{"application/json":{"schema":{"$ref":"#/components/schemas/NotAuthenticatedResponse.v1"}}}},"404":{"description":"ticket profile was not found","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ErrorResponse.v1"}},"application/vnd.integrisio.servicenow-config.v1+json":{"schema":{"$ref":"#/components/schemas/ErrorResponse.v1"}}}},"415":{"description":"none of the media types requested in the Accept header are supported","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ErrorResponse.v1"}}}},"500":{"description":"there was an error on the server while processing the request","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ErrorResponse.v1"}},"application/vnd.integrisio.servicenow-config.v1+json":{"schema":{"$ref":"#/components/schemas/ErrorResponse.v1"}}}}}},"put":{"tags":["ServiceNow"],"summary":"creates or updates the ticket profile with the given ID","description":"This API updates the settings for a particular ticket profile.\n\nNote that ticket profile names are not case-sensitive, however, they will be stored using the exact case as specified for the name.\n","parameters":[{"name":"organizationId","description":"the ID of the organization this ServiceNow account is tied to","in":"path","required":true,"schema":{"type":"string","nullable":false,"default":null,"example":"D365AA71-F1AB-4BFF-9D15-FCEFCE2D2EAB"}},{"name":"id","description":"the ID of the ticket profile being updated","in":"path","required":true,"schema":{"type":"number","format":"int32","nullable":true,"default":null,"example":17}}],"requestBody":{"required":true,"content":{"application/json":{"schema":{"$ref":"#/components/schemas/ServiceNowTicketProfileRequestBody.v1"}},"application/vnd.integrisio.servicenow-config.v1+json":{"schema":{"$ref":"#/components/schemas/ServiceNowTicketProfileRequestBody.v1"}}}},"responses":{"200":{"description":"the request was successful\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ServiceNowTicketProfileResponse.v1"}},"application/vnd.integrisio.servicenow-config.v1+json":{"schema":{"$ref":"#/components/schemas/ServiceNowTicketProfileResponse.v1"}}}},"400":{"description":"there is an issue with the client request","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ErrorResponse.v1"}},"application/vnd.integrisio.servicenow-config.v1+json":{"schema":{"$ref":"#/components/schemas/ErrorResponse.v1"}}}},"401":{"description":"the user is not authenticated with the API","content":{"application/json":{"schema":{"$ref":"#/components/schemas/NotAuthenticatedResponse.v1"}}}},"404":{"description":"the ticket profile was not found","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ErrorResponse.v1"}},"application/vnd.integrisio.servicenow-config.v1+json":{"schema":{"$ref":"#/components/schemas/ErrorResponse.v1"}}}},"409":{"description":"multiple ticket profiles with the given name were found","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ErrorResponse.v1"}},"application/vnd.integrisio.servicenow-config.v1+json":{"schema":{"$ref":"#/components/schemas/ErrorResponse.v1"}}}},"415":{"description":"none of the media types requested in the Accept header are supported","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ErrorResponse.v1"}}}},"500":{"description":"there was an error on the server while processing the request","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ErrorResponse.v1"}},"application/vnd.integrisio.servicenow-config.v1+json":{"schema":{"$ref":"#/components/schemas/ErrorResponse.v1"}}}}}},"delete":{"tags":["ServiceNow"],"summary":"removes the ticket profile with the given ID","description":"This API removes a particular ticket profile.\n","parameters":[{"name":"organizationId","description":"the ID of the organization this ServiceNow account is tied to","in":"path","required":true,"schema":{"type":"string","nullable":false,"default":null,"example":"D365AA71-F1AB-4BFF-9D15-FCEFCE2D2EAB"}},{"name":"id","description":"the ID of the ticket profile being removed","in":"path","required":true,"schema":{"type":"string","nullable":true,"default":null,"example":"3FFAC6F2-8295-4E9F-9788-0BC6089BCC6D"}}],"responses":{"200":{"description":"the request was successful\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/SuccessResponse.v1"}},"application/vnd.integrisio.servicenow-config.v1+json":{"schema":{"$ref":"#/components/schemas/SuccessResponse.v1"}}}},"400":{"description":"there is an issue with the client request","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ErrorResponse.v1"}},"application/vnd.integrisio.servicenow-config.v1+json":{"schema":{"$ref":"#/components/schemas/ErrorResponse.v1"}}}},"401":{"description":"the user is not authenticated with the API","content":{"application/json":{"schema":{"$ref":"#/components/schemas/NotAuthenticatedResponse.v1"}}}},"404":{"description":"the ticket profile was not found","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ErrorResponse.v1"}},"application/vnd.integrisio.servicenow-config.v1+json":{"schema":{"$ref":"#/components/schemas/ErrorResponse.v1"}}}},"409":{"description":"multiple ticket profiles with the given name were found","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ErrorResponse.v1"}},"application/vnd.integrisio.servicenow-config.v1+json":{"schema":{"$ref":"#/components/schemas/ErrorResponse.v1"}}}},"415":{"description":"none of the media types requested in the Accept header are supported","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ErrorResponse.v1"}}}},"500":{"description":"there was an error on the server while processing the request","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ErrorResponse.v1"}},"application/vnd.integrisio.servicenow-config.v1+json":{"schema":{"$ref":"#/components/schemas/ErrorResponse.v1"}}}}}}},"/api/apps/servicenow/settings/:organizationId/ticketTypes":{"get":{"tags":["ServiceNow"],"summary":"gets the available ticket types which can be created in ServiceNow","description":"This API determines which ticket types (tables) in ServiceNow the user has the ability to create tickets in and returns the resulting list.\n\nYou must call the 'connect' API call before attempting to call this API.\n","parameters":[{"name":"organizationId","description":"the ID of the organization this ServiceNow account is tied to","in":"path","required":true,"schema":{"type":"string","nullable":false,"default":null,"example":"D365AA71-F1AB-4BFF-9D15-FCEFCE2D2EAB"}}],"responses":{"200":{"description":"the request was successful\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ServiceNowTicketTypeListResponse.v1"}},"application/vnd.integrisio.servicenow-config.v1+json":{"schema":{"$ref":"#/components/schemas/ServiceNowTicketTypeListResponse.v1"}}}},"400":{"description":"there is an issue with the client request","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ErrorResponse.v1"}},"application/vnd.integrisio.servicenow-config.v1+json":{"schema":{"$ref":"#/components/schemas/ErrorResponse.v1"}}}},"401":{"description":"the user is not authenticated with the API","content":{"application/json":{"schema":{"$ref":"#/components/schemas/NotAuthenticatedResponse.v1"}}}},"415":{"description":"none of the media types requested in the Accept header are supported","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ErrorResponse.v1"}}}},"500":{"description":"there was an error on the server while processing the request","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ErrorResponse.v1"}},"application/vnd.integrisio.servicenow-config.v1+json":{"schema":{"$ref":"#/components/schemas/ErrorResponse.v1"}}}}}}},"/api/apps/servicenow/settings/:organizationId/ticketTypes/:sysId/fields":{"get":{"tags":["ServiceNow"],"summary":"gets the available fields for the given ticket type","description":"This API determines which fields can be populated by the user for the given ticket type and returns the resulting list.\n\nYou must call the 'connect' API call before attempting to call this API.\n","parameters":[{"name":"organizationId","description":"the ID of the organization this ServiceNow account is tied to","in":"path","required":true,"schema":{"type":"string","nullable":false,"default":null,"example":"D365AA71-F1AB-4BFF-9D15-FCEFCE2D2EAB"}},{"name":"sysId","description":"the unique ticket type system ID from ServiceNow","in":"path","required":true,"schema":{"type":"string","nullable":false,"default":null,"example":"10843fb8dbd980108596d426ca961952"}}],"responses":{"200":{"description":"the request was successful\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ServiceNowTicketFieldListResponse.v1"}},"application/vnd.integrisio.servicenow-config.v1+json":{"schema":{"$ref":"#/components/schemas/ServiceNowTicketFieldListResponse.v1"}}}},"400":{"description":"there is an issue with the client request","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ErrorResponse.v1"}},"application/vnd.integrisio.servicenow-config.v1+json":{"schema":{"$ref":"#/components/schemas/ErrorResponse.v1"}}}},"401":{"description":"the user is not authenticated with the API","content":{"application/json":{"schema":{"$ref":"#/components/schemas/NotAuthenticatedResponse.v1"}}}},"404":{"description":"the ticket type was not found","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ErrorResponse.v1"}},"application/vnd.integrisio.servicenow-config.v1+json":{"schema":{"$ref":"#/components/schemas/ErrorResponse.v1"}}}},"415":{"description":"none of the media types requested in the Accept header are supported","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ErrorResponse.v1"}}}},"500":{"description":"there was an error on the server while processing the request","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ErrorResponse.v1"}},"application/vnd.integrisio.servicenow-config.v1+json":{"schema":{"$ref":"#/components/schemas/ErrorResponse.v1"}}}}}}},"/api/apps/servicenow/settings/:organizationId/url":{"get":{"tags":["ServiceNow"],"summary":"gets the URL for the ServiceNow server","description":"This API call returns the currently configured URL for ServiceNow.\n","parameters":[{"name":"organizationId","description":"the ID of the organization this ServiceNow account is tied to","in":"path","required":true,"schema":{"type":"string","nullable":false,"default":null,"example":"D365AA71-F1AB-4BFF-9D15-FCEFCE2D2EAB"}}],"responses":{"200":{"description":"the request was successful\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ServiceNowUrlResponse.v1"}},"application/vnd.integrisio.servicenow-config.v1+json":{"schema":{"$ref":"#/components/schemas/ServiceNowUrlResponse.v1"}}}},"400":{"description":"there is an issue with the client request","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ErrorResponse.v1"}},"application/vnd.integrisio.servicenow-config.v1+json":{"schema":{"$ref":"#/components/schemas/ErrorResponse.v1"}}}},"401":{"description":"the user is not authenticated with the API","content":{"application/json":{"schema":{"$ref":"#/components/schemas/NotAuthenticatedResponse.v1"}}}},"404":{"description":"no URL has been set","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ErrorResponse.v1"}},"application/vnd.integrisio.servicenow-config.v1+json":{"schema":{"$ref":"#/components/schemas/ErrorResponse.v1"}}}},"409":{"description":"multiple URL settings were found","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ErrorResponse.v1"}},"application/vnd.integrisio.servicenow-config.v1+json":{"schema":{"$ref":"#/components/schemas/ErrorResponse.v1"}}}},"415":{"description":"none of the media types requested in the Accept header are supported","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ErrorResponse.v1"}}}},"500":{"description":"there was an error on the server while processing the request","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ErrorResponse.v1"}},"application/vnd.integrisio.servicenow-config.v1+json":{"schema":{"$ref":"#/components/schemas/ErrorResponse.v1"}}}}}},"put":{"tags":["ServiceNow"],"summary":"sets or updates the URL for the ServiceNow server","description":"This sets the \"base\" URL for ServiceNow where all API calls will be made.\n\nYou should call the \"connect\" API to ensure the new URL is working properly after setting it.\n","parameters":[{"name":"organizationId","description":"the ID of the organization this ServiceNow account is tied to","in":"path","required":true,"schema":{"type":"string","nullable":false,"default":null,"example":"D365AA71-F1AB-4BFF-9D15-FCEFCE2D2EAB"}}],"requestBody":{"required":true,"content":{"application/json":{"schema":{"$ref":"#/components/schemas/ServiceNowUrlRequestBody.v1"}},"application/vnd.integrisio.servicenow-config.v1+json":{"schema":{"$ref":"#/components/schemas/ServiceNowUrlRequestBody.v1"}}}},"responses":{"200":{"description":"the request was successful\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/SuccessResponse.v1"}},"application/vnd.integrisio.servicenow-config.v1+json":{"schema":{"$ref":"#/components/schemas/SuccessResponse.v1"}}}},"400":{"description":"there is an issue with the client request","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ErrorResponse.v1"}},"application/vnd.integrisio.servicenow-config.v1+json":{"schema":{"$ref":"#/components/schemas/ErrorResponse.v1"}}}},"401":{"description":"the user is not authenticated with the API","content":{"application/json":{"schema":{"$ref":"#/components/schemas/NotAuthenticatedResponse.v1"}}}},"409":{"description":"multiple URL settings were found","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ErrorResponse.v1"}},"application/vnd.integrisio.servicenow-config.v1+json":{"schema":{"$ref":"#/components/schemas/ErrorResponse.v1"}}}},"415":{"description":"none of the media types requested in the Accept header are supported","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ErrorResponse.v1"}}}},"500":{"description":"there was an error on the server while processing the request","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ErrorResponse.v1"}},"application/vnd.integrisio.servicenow-config.v1+json":{"schema":{"$ref":"#/components/schemas/ErrorResponse.v1"}}}}}}}}}